'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _sourceMapSupport2 = require('source-map-support');

var _util = require('util');

var _util2 = _interopRequireDefault(_util);

var _ansiEscapes = require('ansi-escapes');

var _ansiEscapes2 = _interopRequireDefault(_ansiEscapes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

(0, _sourceMapSupport2.install)();

var CLInterface = function () {
    function CLInterface() {
        var _context;

        (0, _classCallCheck3.default)(this, CLInterface);

        this.i = 0;
        this.stdoutBuffer = [];
        this.stderrBuffer = [];
        this.out = (_context = process.stdout).write.bind(_context);
        this.err = (_context = process.stderr).write.bind(_context);

        this.clearAll();

        /**
         * don't modify stdout and stderr streams for unit tests
         */
        /* istanbul ignore if */
        if (!process.env.WDIO_TEST) {
            this.wrapStdio(process.stdout, this.stdoutBuffer);
            this.wrapStdio(process.stderr, this.stderrBuffer);
        }
    }

    (0, _createClass3.default)(CLInterface, [{
        key: 'wrapStdio',
        value: function wrapStdio(stream, buffer) {
            stream.write = function (chunk) {
                buffer.push(chunk);
                return true;
            };
        }
    }, {
        key: 'clearAll',
        value: function clearAll() {
            this.out(_ansiEscapes2.default.clearScreen);
        }
    }, {
        key: 'clearLine',
        value: function clearLine() {
            this.out(_ansiEscapes2.default.eraseStartLine);
            this.out(_ansiEscapes2.default.cursorLeft);
        }
    }, {
        key: 'log',
        value: function log() {
            for (var _len = arguments.length, messages = Array(_len), _key = 0; _key < _len; _key++) {
                messages[_key] = arguments[_key];
            }

            this.out(_util2.default.format.apply(this, messages) + '\n');
        }
    }, {
        key: 'write',
        value: function write(message) {
            this.out(message);
        }
    }]);
    return CLInterface;
}();

exports.default = CLInterface;
module.exports = exports['default'];